'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _codemirror = require('codemirror');

var _codemirror2 = _interopRequireDefault(_codemirror);

var _theme2 = require('@storybook/components/dist/theme');

var _constants = require('../../constants');

var _styles = require('./styles');

var themes = _interopRequireWildcard(_styles);

require('codemirror/mode/javascript/javascript');

require('codemirror/mode/jsx/jsx');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LiveEditor = function (_React$Component) {
    _inherits(LiveEditor, _React$Component);

    function LiveEditor() {
        var _ref;

        _classCallCheck(this, LiveEditor);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        // $FlowIgnore
        var _this = _possibleConstructorReturn(this, (_ref = LiveEditor.__proto__ || Object.getPrototypeOf(LiveEditor)).call.apply(_ref, [this].concat(_toConsumableArray(args))));

        _this.state = {
            code: null,
            theme: _this.props.theme
        };
        _this.loadSource = _this.loadSource.bind(_this);
        // $FlowIgnore
        _this.loadOptions = _this.loadOptions.bind(_this);
        // $FlowIgnore
        _this.onSourceChange = _this.onSourceChange.bind(_this);
        // $FlowIgnore
        _this.setCodeMirrorRef = _this.setCodeMirrorRef.bind(_this);
        // $FlowIgnore
        _this.codemirrorValueChanged = _this.codemirrorValueChanged.bind(_this);
        return _this;
    }

    _createClass(LiveEditor, [{
        key: 'loadSource',
        value: function loadSource(code) {
            this.setState({ code: code });
        }
    }, {
        key: 'loadOptions',
        value: function loadOptions(options) {
            this.setState({ theme: options.theme });
        }
    }, {
        key: 'onSourceChange',
        value: function onSourceChange(code) {
            this.props.channel.emit(_constants.event.UpdateSource, code);
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.channel.on(_constants.event.LoadSource, this.loadSource);
            this.props.channel.on(_constants.event.SyncOptions, this.loadOptions);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.props.channel.removeListener(_constants.event.LoadSource, this.loadSource);
            this.props.channel.removeListener(_constants.event.SyncOptions, this.loadOptions);
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate() {
            if (this.state.code !== null) {
                var _theme = (0, _utils.themeNameToVarName)(this.state.theme) in themes ? this.state.theme : 'default';
                if (!this.codeMirror) {
                    this.codeMirror = (0, _codemirror2.default)(this.codeMirrorRef, { mode: 'jsx', theme: _theme });
                    this.codeMirror.on('change', this.codemirrorValueChanged);
                } else {
                    this.codeMirror.setOption('theme', _theme);
                }
                // $FlowIgnore
                this.codeMirror.setValue(this.state.code);
            } else {
                this.codeMirror = null;
            }
        }
    }, {
        key: 'codemirrorValueChanged',
        value: function codemirrorValueChanged(doc, change) {
            if (change.origin !== 'setValue') {
                this.onSourceChange(doc.getValue());
            }
        }
    }, {
        key: 'setCodeMirrorRef',
        value: function setCodeMirrorRef(el) {
            this.codeMirrorRef = el;
        }
    }, {
        key: 'render',
        value: function render() {
            if (this.state.code === null) {
                return React.createElement(
                    'div',
                    {
                        style: _extends({}, _theme2.baseFonts, {
                            width: '100%',
                            textAlign: 'center',
                            padding: '20px',
                            color: 'gray',
                            textTransform: 'uppercase'
                        })
                    },
                    'Editor unavailable'
                );
            }

            var themeVarName = (0, _utils.themeNameToVarName)(this.state.theme);
            return React.createElement(
                'div',
                { style: { width: '100%', display: 'flex', flex: '1 1' } },
                themeVarName in themes && React.createElement('style', { dangerouslySetInnerHTML: { __html: themes[themeVarName] } }),
                React.createElement('style', { dangerouslySetInnerHTML: { __html: themes.default } }),
                React.createElement('style', {
                    dangerouslySetInnerHTML: { __html: '\n                        div.CodeMirror {\n                            width: 100%;\n                            height: initial;\n                        }\n                    ' }
                }),
                React.createElement('div', { style: { minWidth: '100%', minHeight: '100%', display: 'flex', flex: '1 1' }, ref: this.setCodeMirrorRef })
            );
        }
    }]);

    return LiveEditor;
}(React.Component);

exports.default = LiveEditor;
//# sourceMappingURL=index.js.map