'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _error_display = require('@storybook/react/dist/client/preview/error_display');

var _error_display2 = _interopRequireDefault(_error_display);

var _constants = require('../constants');

var _transform = require('../transform');

var _transform2 = _interopRequireDefault(_transform);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LivePreview = function (_React$Component) {
    _inherits(LivePreview, _React$Component);

    function LivePreview() {
        var _ref;

        _classCallCheck(this, LivePreview);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        // $FlowIgnore
        var _this = _possibleConstructorReturn(this, (_ref = LivePreview.__proto__ || Object.getPrototypeOf(LivePreview)).call.apply(_ref, [this].concat(_toConsumableArray(args))));

        _this.state = {
            code: _this.props.code
        };
        _this.setSource = _this.setSource.bind(_this);
        return _this;
    }

    _createClass(LivePreview, [{
        key: 'setSource',
        value: function setSource(code) {
            this.setState({ code: code });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            this.props.channel.on(_constants.event.UpdateSource, this.setSource);
            this.props.channel.emit(_constants.event.LoadSource, this.props.code);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.props.channel.emit(_constants.event.LoadSource, null);
            this.props.channel.removeListener(_constants.event.UpdateSource, this.setSource);
        }
    }, {
        key: 'render',
        value: function render() {
            try {
                return (0, _transform2.default)(this.state.code, this.props.scope || {})();
            } catch (e) {
                return React.createElement(_error_display2.default, { error: e });
            }
        }
    }]);

    return LivePreview;
}(React.Component);

exports.default = LivePreview;
//# sourceMappingURL=LivePreview.js.map